SystemOrganization addCategory: #'Glamour-Morphic'!

Announcer subclass: #GLMMorphicModel
	instanceVariableNames: 'glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicModel subclass: #GLMListModel
	instanceVariableNames: 'items selection displaySelector searchText searchBlock singleSelection filterBlock filteredItems menuBlock dynamicMenu onSelectionBlock selectedIndexes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:00'!
canonicalItems
	^ items! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 01:04'!
displayListAt: anIndex
	^ self glamourPresentation formatedDisplayValueOf: (self items at: anIndex)! !

!GLMListModel methodsFor: 'accessing' stamp: 'david_roethlisberger 3/2/2009 11:03'!
displaySelector: aSymbol
	displaySelector := aSymbol! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:20'!
displayedItems
	^ self items collect: [:each | displaySelector glamourValue: each]
! !

!GLMListModel methodsFor: 'associating' stamp: 'jre 8/1/2009 13:22'!
doSearch
	searchText isEmptyOrNil
		ifTrue: [ self executeReset ]
		ifFalse:[ 
			searchBlock isNil 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
		
	! !

!GLMListModel methodsFor: 'associating' stamp: 'jre 8/1/2009 13:22'!
executeFilter
	filteredItems := filterBlock value: self searchText asString value: self canonicalItems.
	self changed: #displayedItems; changed: #selection
	! !

!GLMListModel methodsFor: 'associating' stamp: 'a'!
executeReset
	filteredItems := self canonicalItems.
	self changed: #items; changed: #selection
	! !

!GLMListModel methodsFor: 'associating' stamp: 'tg 8/1/2009 20:07'!
executeSearch
	| searchResult |
	searchResult := searchBlock 
		value: self searchText asString
		value: self canonicalItems.
	selectedIndexes := ((1 to: self canonicalItems size) select: [ :eachIndex | searchResult includes: (self canonicalItems at: eachIndex) ]) asOrderedCollection.
	onSelectionBlock ifNotNil: [ onSelectionBlock value: searchResult ].
	self changed: #allSelections
	"self changed: #displayedItems; changed: #selection"! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 7/31/2009 23:00'!
filterBlock: aBlock
	filterBlock := aBlock! !

!GLMListModel methodsFor: 'initialization' stamp: 'tg 7/31/2009 22:39'!
initialize
	super initialize.
	selection := 0.
	searchText := ''
	"searchBlock := [:text :list | OrderedCollection new]"! !

!GLMListModel methodsFor: 'testing' stamp: 'tg 8/1/2009 20:06'!
isMultiple
	^ self selectedIndexes isNil not! !

!GLMListModel methodsFor: 'accessing' stamp: 'jre 8/1/2009 13:20'!
items
	^ filteredItems! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 14:29'!
items: aCollection
	| nonSetCollection |
	nonSetCollection := (aCollection isKindOf: Set) ifTrue: [aCollection asOrderedCollection] ifFalse: [aCollection].
	items := nonSetCollection.
	filteredItems := nonSetCollection.! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 23:23'!
listAt: anIndex
	^ self items at: anIndex! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:06'!
listSelectionAt: anIndex 
	^ self selectedIndexes includes: anIndex! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:48'!
listSelectionAt: anIndex put: aValue 
	aValue = true
		ifTrue: [ (self selectedIndexes includes: anIndex) ifFalse: [ self selectedIndexes add: anIndex ] ]
		ifFalse: [ self selectedIndexes remove: anIndex ifAbsent: [  ] ].
	onSelectionBlock ifNotNil: [
		onSelectionBlock value: self selectedItems ].
	self changed: #selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 10:54'!
listSize
	^self items size! !

!GLMListModel methodsFor: 'updating' stamp: 'tg 8/1/2009 19:57'!
onSelection: aBlock 
	onSelectionBlock := aBlock! !

!GLMListModel methodsFor: 'accessing' stamp: 'jorge.ressia 5/26/2009 12:19'!
searchBlock: aBlock
	searchBlock := aBlock! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 5/20/2009 14:43'!
searchEnabled
	^ true! !

!GLMListModel methodsFor: 'accessing' stamp: 'a'!
searchText
	^ searchText! !

!GLMListModel methodsFor: 'accessing' stamp: 'a'!
searchText: aString
	searchText := aString.
	self doSearch
! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 02:24'!
selectItem: anObject 
	| index |
	index := 0.
	self items withIndexDo: [:each :i | each == anObject ifTrue: [index := i]].
	selection := index.
	self changed: #singleSelection.! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 8/1/2009 20:07'!
selectedIndexes
	"this only holds the indexes of the selected items in terms of the entire collection of items"
	^ selectedIndexes ifNil: [ selectedIndexes := OrderedCollection new ]! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 02:13'!
selectedIndexes: aCollection
	selectedIndexes := aCollection! !

!GLMListModel methodsFor: 'accessing' stamp: 'tg 8/1/2009 20:49'!
selectedItems
	"This holds the collection of the actual selected items. It must be in sync with the selectedIndexes"
	^  self items species withAll: (self selectedIndexes collect: [ :eachIndex | self listAt: eachIndex ])! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 22:51'!
selection 
	^ selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 19:59'!
selection: anIndex
	selection := anIndex. 
	self changed: #selection.! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 7/31/2009 22:51'!
singleSelection 
	^ selection! !

!GLMListModel methodsFor: 'callbacks' stamp: 'tg 8/1/2009 20:03'!
singleSelection: anIndex 
	self flag: 'What is the difference between singleSelection and selection?'.
	anIndex == 0 ifFalse: 
		[ selection := anIndex.
		onSelectionBlock ifNotNil: [ onSelectionBlock value: (self listAt: anIndex) ] ].
	self changed: #singleSelection! !

GLMListModel subclass: #GLMMultiListModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMultiListModel methodsFor: 'as yet unclassified' stamp: 'tg 9/9/2009 22:45'!
selectItem: aCollection
	| indexes |
	indexes := OrderedCollection new.
	self items withIndexDo: [:each :i | 
		aCollection asOrderedCollection do: [:anObject |
			each == anObject ifTrue: [indexes add: i]
		]
	].
	self selectedIndexes: indexes.
	self changed: #selection.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
allKeystrokeActions
	^ self glamourPresentation allActions select: [:action | action hasShortcut ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:24'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'jre 7/31/2009 09:48'!
executeMenuAction: anAction
	self announce: (GLMMenuItemSelected action: anAction)! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation
	^ glamourPresentation! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMMorphicModel methodsFor: 'initialization' stamp: 'tg 8/4/2009 15:26'!
initialize
	super initialize.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
keystroke: aChar from: aMorph
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aChar] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ].! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 9/8/2009 14:46'!
menu: aMenuMorph 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

GLMMorphicModel subclass: #GLMTextModel
	instanceVariableNames: 'text highlightSmalltalk highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/7/2009 02:03'!
accept: aText notifying: anObject 
	aText asString withBlanksTrimmed ifEmpty: [^self].
	text := aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk: anObject
	highlightSmalltalk := anObject! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext: anObject
	highlightSmalltalkContext := anObject! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 3/2/2009 16:22'!
keystroke: anEvent from: aMorph
	anEvent anyModifierKeyPressed ifTrue: [super keystroke: anEvent keyCharacter from: aMorph]! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:31'!
menu: aMorphMenu shifted: b
	^ self menu: aMorphMenu! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 5/14/2009 22:10'!
selectSilently: anIndex
	self changed: #selection! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
selection
	^ 1 to: 0! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:42'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext notNil ifTrue: [
		aPluggableShoutMorph classOrMetaClass: self highlightSmalltalkContext].
	^ true! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 11:51'!
text: aTextOrString
	text := aTextOrString! !

GLMMorphicModel subclass: #GLMTreeModel
	instanceVariableNames: 'roots selection childrenBlock onSelection displaySelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock
	^childrenBlock! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:24'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'tg 5/6/2009 10:56'!
displaySelector: aSymbol
	displaySelector := aSymbol! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:56'!
geSelectionPath
	^self selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'tg 9/6/2009 16:11'!
getChildrenOf: aNode
	^childrenBlock isNil 
		ifTrue: [OrderedCollection new]
		ifFalse: [childrenBlock glamourValue: aNode]! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'tg 9/9/2009 01:29'!
getLabelOf: anObject
	^ self glamourPresentation formatedDisplayValueOf: anObject! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:32'!
hasChildren: aNode
	^(self getChildrenOf: aNode) notEmpty! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:12'!
nodeAt: pathCollection
	^self nodeAt: pathCollection allButFirst for: self roots! !

!GLMTreeModel methodsFor: 'private' stamp: 'david_roethlisberger 2/27/2009 14:26'!
nodeAt: pathCollection for: childrenCollection
	| node |
	node := childrenCollection at: pathCollection first.
	^pathCollection size > 1 ifTrue: [self nodeAt: pathCollection allButFirst for: (childrenBlock value: node)] ifFalse: [node]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:38'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 13:54'!
roots
	^roots! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 14:22'!
roots: aCollectionOrElement
	roots := aCollectionOrElement isCollection ifTrue: [aCollectionOrElement] ifFalse: [OrderedCollection with: aCollectionOrElement]! !

!GLMTreeModel methodsFor: 'accessing' stamp: 'david_roethlisberger 2/27/2009 13:57'!
selection
	^selection! !

!GLMTreeModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 14:39'!
selection: aNode
     selection := aNode.
	onSelection ifNotNil: [onSelection value: aNode].
	self changed: #selection.! !

PluggableListMorph subclass: #GLMPluggableListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMPluggableListMorph methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 22:16'!
listMorphClass
	^GLMLazyListMorph! !

ListItemWrapper subclass: #GLMTreeMorphNodeModel
	instanceVariableNames: 'parentNode contents containerTree onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:21'!
childrenItems
	^ self containerTree childrenBlock glamourValue: self item! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:49'!
classButtonRow
	^ UITheme current newRowIn: World for: {self displayText}! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree
	^ containerTree! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree: anObject
	containerTree := anObject! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 12:18'!
contents
	^ contents ifNil: [
		contents := self childrenItems collect: [:d | 
			(self class with: d) 
				parentNode: self;
				containerTree: self containerTree;
				yourself ] ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:59'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self containerTree glamourPresentation formatedDisplayValueOf: self item) ! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'alain.plantec 9/8/2009 14:37'!
enabled
	^ true! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/10/2009 01:46'!
executeMenuAction: anAction
	self containerTree announce: (GLMMenuItemSelected action: anAction)! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 22:36'!
expandParentPath
	self containerTree changed: {#roots. #openItemPath}, (self path collect: [:each | each item]).! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 9/13/2009 04:07'!
hasTags: aCollection
	^ aCollection allSatisfy: [ :each |
		(self containerTree glamourPresentation tagsFor: self item ) includes: each ] ! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:54'!
icon
	^ self containerTree glamourPresentation iconFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/8/2009 21:09'!
keyStroke: aCharacter from: aTreeMorph 
	^ false
! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/10/2009 01:47'!
menu: aMenuMorph shifted: b 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self containerTree allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
path
	^ self pathIn: OrderedCollection new.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 12:44'!
pathIn: aCollection 
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:53'!
pressedTag: aTag
	self containerTree showOnlyNodesTaggedAs: aTag! !

!GLMTreeMorphNodeModel methodsFor: 'printing' stamp: 'tg 9/9/2009 13:30'!
printOn: aStream
	aStream nextPutAll: 'a NodeModel with '.
	aStream nextPutAll: self item printString.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/14/2009 15:09'!
rowMorphListFor: aContainer 
	| row button |
	row := OrderedCollection with: (UITheme current newRowIn: World for: {self displayText}).
	self containerTree glamourPresentation hasTags ifTrue: [
		(self containerTree glamourPresentation tagsFor: self item) do: [:each |
			button := SimpleButtonMorph new.
			button
				label: each font: (StrikeFont familyName: #Accuny size: 8);
				borderStyle: (BorderStyle inset width: 1);
				extent: button extent - 3;
				borderColor: Color gray;
				color: Color lightGray;
				target: self;
				actionSelector: #pressedTag:;
				arguments: (Array with: each);
				useRoundedCorners.
			row addLast: button
		]
	].
	^ row! !

!GLMTreeMorphNodeModel methodsFor: 'enumerating' stamp: 'tg 9/9/2009 13:42'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

RectangleMorph subclass: #GLMPaneScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:43'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: ''!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPaneScroller methodsFor: 'private' stamp: 'jorge.ressia 5/25/2009 16:25'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'jorge.ressia 5/25/2009 16:29'!
initialize
	super initialize.
	self 
		color: Color white;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	paneCount := 0.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: ''!
initializeScrollbar
	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'david_roethlisberger 3/18/2009 14:26'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
innerBounds
	| rect |
	rect := super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
isScrollable
	^ self leftoverScrollRange > 0! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
layoutWidgets
	| inner outer |
	outer := super innerBounds.
	inner := self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom)
						corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'david_roethlisberger 3/18/2009 15:05'!
maxPanes
	^2! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'jorge.ressia 5/25/2009 16:18'!
paneCount
	^ paneCount! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneHeight
	^ transform bounds height! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
resizeScrollBar
	| inner outer |
	outer := super innerBounds.
	inner := outer withHeight: outer height - self scrollBarHeight.
	scrollBar bounds: ((inner left @ inner bottom) corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
scrollBarHeight
	^ self theme scrollbarThickness! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!GLMPaneScroller methodsFor: 'input events' stamp: ''!
scrollBarMenuButtonPressed: anObject! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollDeltaWidth
	^ 1! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollToRight
	^ scrollBar setValue: 1.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
separator
	^ BorderedSubpaneDividerMorph vertical
		adoptPaneColor: self paneColor;
		yourself! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:28'!
separatorWidth
	^3! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'david_roethlisberger 3/18/2009 14:27'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'jorge.ressia 5/25/2009 16:40'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicRenderer commentStamp: 'tg 5/24/2009 21:22' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTableLayoutBrowser new.
browser column: #one; column: #two.

browser showOn: #one; using: [browser list.].
browser showOn: #two; from: #one; using: [
	browser text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'factory' stamp: ''!
emptyMorph
	^ RectangleMorph new
		layoutPolicy: ProportionalLayout new;
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		yourself! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 8/4/2009 15:27'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action actOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 7/28/2009 20:46'!
open: aRenderable
	| window |
	window := GlamorousSystemWindow new.
	window model: aRenderable; setLabel: aRenderable titleValue.
	window 
		addMorph: (self render: aRenderable)
		fullFrame: (LayoutFrame new
				leftFraction: 0;
				rightFraction: 1;
				topFraction: 0;
				bottomFraction: 1).
	^ window openInWorld! !

!GLMMorphicRenderer methodsFor: 'private' stamp: ''!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition |
	totalSpans := aCell children
		inject: 0
		into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId
			ifTrue: [ pane := self render: (aBrowser paneNamed: each id) ]
			ifFalse: [
				self
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := self emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane 
			layoutFrame: (LayoutFrame new
				topFraction: currentSpanPosition / totalSpans offset: 0;
				leftFraction: 0 offset: 0;
				bottomFraction: currentSpanPosition + each span / totalSpans offset: 0;
				rightFraction: 1 offset: 0;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span ].
	aMorph addPaneSplitters! !

!GLMMorphicRenderer methodsFor: 'private' stamp: ''!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition |
	totalSpans := aCell children
		inject: 0
		into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId
			ifTrue: [ pane := self render: (aBrowser paneNamed: each id) ]
			ifFalse: [
				self
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := self emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane
			layoutFrame: (LayoutFrame new 
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: 0;
				bottomFraction: 1 offset: 0;
				rightFraction: currentSpanPosition + each span / totalSpans offset: 0;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span ].
	aMorph addPaneSplitters! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: ''!
renderFinder: aBrowser 
	| container |
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | container popPane.].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | container pushPane: (self render: ann pane) ].
	aBrowser panes
		do: [ :each | container pushPane: (self render: each) ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/9/2009 02:14'!
renderListPresentation: aListPresentation 
	| items list toShow listModel container search |
	toShow := aListPresentation displayValue.
	items := toShow isCollection
				ifTrue: [toShow]
				ifFalse: [OrderedCollection with: toShow].
	listModel := (aListPresentation isMultiple ifTrue: [GLMMultiListModel new] ifFalse: [GLMListModel new])
				glamourPresentation: aListPresentation;
				items: items;
				displaySelector: aListPresentation format;
				searchBlock: aListPresentation searchStrategy;
				filterBlock: aListPresentation filterStrategy;
				yourself.
	container := self emptyMorph.
	list := aListPresentation isMultiple
				ifTrue: [
					PluggableListMorphOfMany
						on: listModel
						list: #displayedItems
						primarySelection: #selection
						changePrimarySelection: #selection:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: #menu
						keystroke: #keystroke:from:]
				ifFalse: [
					PluggableListMorph
						on: listModel 
						list: #displayedItems 
						selected: #singleSelection 
						changeSelected: #singleSelection: 
						menu: #menu
						keystroke: #keystroke:from: ].
	list
		color: Color white;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		getMenuSelector: #menu:;
		alwaysShowScrollBars: false;
		keystrokeActionSelector: #keystroke:from:;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	self installActionsOnUI: listModel fromPresentation: aListPresentation.
	listModel onSelection: [:selection | aListPresentation selection: selection].
	aListPresentation allowsInput ifTrue: [
		search := UITheme current
			newTextEntryIn: nil
			for: listModel
			get: #searchText
			set: #searchText:
			class: String
			getEnabled: #searchEnabled
			help: 'Search Input'.
		search layoutFrame: (LayoutFrame
			fractions: (0 @ 1 corner: 1 @ 1) 
			offsets: (0 @ -24 corner: 0 @ 0)).
		list layoutFrame bottomOffset: -24.
		container addMorphBack: search ].
	container addMorphBack: list.
	aListPresentation when: GLMContextChanged do: [:ann | 
		ann property = #selection ifTrue: [listModel selectItem: ann value ]].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/31/2009 17:47'!
renderMagrittePresentation: anAsMorphPresentation 
	| toShow description magritteMorph scrollPane |
	
	toShow := anAsMorphPresentation displayValue.
	description := (anAsMorphPresentation magritteDescription glamourValue: toShow) copy.
	description morphClass: MASilentContainerMorph.
	magritteMorph := (description asMorphOn: toShow) 
		addButtons;
		morph.
	magritteMorph
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill.
	scrollPane := ScrollPane new.
	scrollPane
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill.
	scrollPane scroller addMorph: magritteMorph.
	^ scrollPane
! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: ''!
renderMondrianPresentation: aMondrianPresentation 
	 
	| canvas view canvasScrollPane | 
	view := MOViewRenderer new.
	aMondrianPresentation renderOn: view. 
	canvas := MOCanvas new. 
	canvas root: view root.
	canvas announcer
		when: MOFigureSelection
		do: [ :ann | aMondrianPresentation selection: ann element model ].
	canvasScrollPane := ScrollPane new.
	canvasScrollPane scroller addMorph: canvas.	
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	^ canvasScrollPane
	

"	aMondrianPresentation 
		whenContextChanged: 
			[:ann |  
			ann property = #selection 
				ifTrue: 
					[canvas artist drawing deepNodeFigures do: [:each | each deselect]. 
					(canvas artist drawing deepFindNodeWithEntity: ann value) 
						ifNotNil: [:figure | figure fixedSelect]]]. 

	scrollPane := GeneralScrollPane new
		scrollTarget: canvas;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	scrollPane
		minWidth: (canvas width min: Display width // 2) + scrollPane scrollBarThickness;
		minHeight: (canvas height min: Display height // 2).
	canvas width > scrollPane minWidth
		ifTrue: [scrollPane minHeight: scrollPane minHeight + scrollPane scrollBarThickness].

	scrollPane updateScrollbars.
	^ scrollPane
"! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/7/2009 15:22'!
renderPane: aPane 
	| container |
	container := self emptyMorph.
	aPane whenMatchingPresentationsChanged: [:ann |
		container removeAllMorphs;
				addMorph: (self renderPresentationsOf: aPane)
				fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
				adoptPaneColor: container paneColor].
	container
		addMorph: (self renderPresentationsOf: aPane)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
		 adoptPaneColor: container paneColor.
	^ container! !

!GLMMorphicRenderer methodsFor: 'private' stamp: 'tg 9/12/2009 01:21'!
renderPresentationsOf: aPane
	| presentations tabs | 
	presentations := aPane matchingPresentations.
	presentations isEmpty
		ifTrue: [ ^ self emptyMorph ].
	presentations size = 1
		ifTrue: [ ^ self render: presentations first ].
	tabs := LazyTabGroupMorph new. 
	tabs vResizing: #spaceFill; hResizing: #spaceFill.
	tabs cornerStyle: (self theme tabGroupCornerStyleIn: nil).
	tabs font: self theme labelFont.
	presentations do: [ :each | 
		tabs
			addLazyPage: [ self render: each ]
			label: each titleValue ].
	tabs selectedPageIndex: 1.
	^ tabs! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: ''!
renderTableLayoutBrowser: aBrowser 
	| container |
	container := self emptyMorph.
	aBrowser cell isRow
		ifTrue: [
			self
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: [
			self
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/14/2009 15:53'!
renderTextPresentation: aTextPresentation 
	| textMorph toShow textModel | 
	toShow := aTextPresentation formatedDisplayValue. 
	textModel := GLMTextModel new
			text: toShow;
			glamourPresentation: aTextPresentation;
			highlightSmalltalk: aTextPresentation highlightSmalltalk;
			highlightSmalltalkContext: aTextPresentation highlightSmalltalkContext.
	textMorph := (PluggableShoutMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
			onKeyStrokeSend: #keystroke:from: to: textModel;
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
	^textMorph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/13/2009 03:29'!
renderTreePresentation: aTreePresentation	 
	| treeMorph treeModel |
	treeModel := GLMTreeMorphModel new
		glamourPresentation: aTreePresentation;
		roots: aTreePresentation displayValue;
		yourself.
	treeMorph := (MorphTreeMorph new)
			 	on: treeModel 
				list: #roots
				selected: #getCurrentSelection
				changeSelected: #noteNewSelection:
				menu: #menu:shifted:
				keystroke: #keyStroke:from:;
				cornerStyle: #square;
				borderStyle: (BorderStyle inset width: 1);
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				autoDeselect: true;
				yourself.
	self installActionsOnUI: treeModel fromPresentation: aTreePresentation.	
	treeModel onSelection: [:selection | aTreePresentation selection: selection]. 
	treeMorph vShowScrollBar.	
	aTreePresentation when: GLMContextChanged do: [:ann | 
		ann property = #selection ifTrue: [ treeModel selectItem: ann value ]].
	^treeMorph! !

!GLMMorphicRenderer methodsFor: 'factory' stamp: 'a'!
theme
	^ UITheme current! !

LazyListMorph subclass: #GLMLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMLazyListMorph methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 22:17'!
display: item atRow: row on: canvas ! !

AbstractHierarchicalList subclass: #GLMTreeMorphModel
	instanceVariableNames: 'roots rootClass glamourPresentation childrenBlock onSelection displayFormat tagsToFilterBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphModel commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/10/2009 01:53'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 00:17'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 00:16'!
announcer
	^ announcer ifNil: [announcer := Announcer new].! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:24'!
childrenBlock
	^ childrenBlock ifNil: [ childrenBlock := self glamourPresentation children isNil 
		ifFalse: [self glamourPresentation children] ifTrue: [OrderedCollection new] ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
childrenBlock: aBlock
	childrenBlock := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:23'!
displayFormat
	^ displayFormat ifNil: [displayFormat := self glamourPresentation format]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
displayFormat: aBlock 
	displayFormat := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation
	^ glamourPresentation! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/8/2009 15:10'!
keyStroke: aCharacter from: aTreeMorph 
	self getCurrentSelection
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph]! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'alain.plantec 9/8/2009 15:05'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self getCurrentSelection ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'tg 9/8/2009 21:20'!
nodeModelFor: anObject
	^ (GLMTreeMorphNodeModel with: anObject) containerTree: self; yourself! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'tg 9/10/2009 22:41'!
noteNewSelection: x
	x = currentSelection ifTrue: [^ self].
	super noteNewSelection: x.
	onSelection ifNotNil: [onSelection value: (x isNil ifTrue: [nil] ifFalse: [x item])].
	self changed: #selection.! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'tg 9/8/2009 21:40'!
onSelection: aBlock
	onSelection := aBlock! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 04:01'!
resetTagsToFilterBy
	tagsToFilterBy := OrderedCollection new! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 04:26'!
roots
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	^ roots select: [:each | each hasTags: self tagsToFilterBy ]! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'tg 9/8/2009 21:20'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 12:17'!
selectItem: anObject
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				self silentNoteNewSelection: each.
				^ self]]]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 04:27'!
showOnlyNodesTaggedAs: aTag
	self tagsToFilterBy add: aTag.
	self changed: #roots.! !

!GLMTreeMorphModel methodsFor: 'as yet unclassified' stamp: 'tg 9/10/2009 19:32'!
silentNoteNewSelection: x
	x expandParentPath.
	currentSelection := x.
"	self changed: #getCurrentSelection.
	currentSelection ifNil: [^self].
	currentSelection sendSettingMessageTo: self.
	self changed: #selection."! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 03:59'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:18'!
when: anAnnouncement do: aBlock
	self announcer when: anAnnouncement do: aBlock ! !

Announcement subclass: #GLMActionAnnouncement
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMActionAnnouncement classSide methodsFor: 'instance creation' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	^self new action: anAction; yourself! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action
	^action! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	action := anAction! !

GLMActionAnnouncement subclass: #GLMKeyStroke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMActionAnnouncement subclass: #GLMMenuInvoked
	instanceVariableNames: 'menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMenuInvoked classSide methodsFor: 'as yet unclassified' stamp: 'jre 7/31/2009 15:24'!
action: anAction on: aMenuMorph 
	^self new initializeAction: anAction on: aMenuMorph! !

!GLMMenuInvoked methodsFor: 'initialization' stamp: 'jre 7/31/2009 15:43'!
initializeAction: anAction on: aMenuMorph 
	self action: anAction.
	menuMorph := aMenuMorph! !

!GLMMenuInvoked methodsFor: 'accessing' stamp: 'jre 7/31/2009 15:43'!
menuMorph
	^menuMorph! !

GLMActionAnnouncement subclass: #GLMMenuItemSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'lazyPages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
addLazyPage: aBlock label: aStringOrMorph
	self lazyPages add: aBlock.
	self tabSelectorMorph addTab: aStringOrMorph! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:44'!
addPage: aMorph 
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages add: aMorph.! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
addPage: aMorph at: anIndex
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages at: anIndex put: aMorph! !

!LazyTabGroupMorph methodsFor: 'initialization' stamp: 'jre 8/7/2009 10:11'!
initialize
	super initialize.
	lazyPages := OrderedCollection new.
	pageMorphs := Dictionary new.
! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
lazyPages

	^lazyPages! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
pageAt: index
	^self pages at: index ifAbsent: [ self addPage: (self lazyPages at: index) value at: index]! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:20'!
updatePageIndex: index
	"Change to the given page index."

	|p|
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph
				replaceSubmorph: p
				by: (self pageAt: index)].
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor! !

!GLMBrowser methodsFor: '*Glamour-Morphic' stamp: 'tg 5/6/2009 13:16'!
magritte
	^ self custom: GLMMagrittePresentation new! !

SystemWindow subclass: #GlamorousSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GlamorousSystemWindow methodsFor: 'building' stamp: ''!
buildWindowMenu
	^ self model actions isEmpty
		ifTrue: [ super buildWindowMenu ]
		ifFalse: [
			self model actions
				inject: (super buildWindowMenu
					addLine;
					yourself)
				into: [ :menu :action |
					menu
						add: action title target: action selector: #actOn: argument: self model;
						yourself ] ]! !
